#version 330 core

out vec4 FragColor;
in vec2 TexCoords;

uniform sampler2D scene;
uniform sampler2D bloom;
uniform float intens;

void main(){
	float gamma=2.2;

	vec3 sceneColor = texture(scene,TexCoords).rgb;
	vec3 bloomColor = texture(bloom,TexCoords).rgb;

	sceneColor += bloomColor;

	vec3 final = vec3(1.0) - exp(-sceneColor*intens);
	final=pow(final, vec3(1.0/gamma));

	FragColor = vec4(sceneColor, 1.0);
}

