#version 330 core
out vec4 FragColor;
in vec2 TexCoords;

uniform sampler2D img;

uniform bool horiz;
uniform float weight[5] = float[] (0.227027, 0.1945946, 0.1216216, 0.054054, 0.016216);

void main(){
	vec2 tex_off = 1.0/textureSize(img,0);
	vec3 result = texture(img, TexCoords).rgb*weight[0];

	if(horiz){

	 for(int i = 1; i < 5; ++i)
        {
            result += texture(img, TexCoords + vec2(tex_off.x * i, 0.0)).rgb * weight[i];
            result += texture(img, TexCoords - vec2(tex_off.x * i, 0.0)).rgb * weight[i];
        }
	 
	
	}else{

	for(int i = 1; i < 5; ++i)
        {
            result += texture(img, TexCoords + vec2( 0.0,tex_off.y * i)).rgb * weight[i];
            result += texture(img, TexCoords - vec2( 0.0,tex_off.y * i)).rgb * weight[i];
        }
	
	
	}
	

	FragColor = vec4(result, 1.0);


}