#version 430 core

in VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec2 uv;
} vert;

layout (location = 0) out vec4 color;
layout (location = 1) out vec4 part;

uniform vec3 camera_world;

uniform vec3 materialCoefficients; // x = ambient, y = diffuse, z = specular 
uniform float specularAlpha;
uniform sampler2D diffuseTexture;
in float normLifetimeFrag; 


uniform struct DirectionalLight {
	vec3 color;
	vec3 direction;
} dirL;

uniform struct PointLight {
	vec3 color;
	vec3 position;
	vec3 attenuation;
} pointL;


vec3 phong(vec3 n, vec3 l, vec3 v, vec3 diffuseC, float diffuseF, vec3 specularC, float specularF, float alpha, bool attenuate, vec3 attenuation) {
	float d = length(l);
	l = normalize(l);
	float att = 1.0;	
	if(attenuate) att = 1.0f / (attenuation.x + d * attenuation.y + d * d * attenuation.z);
	vec3 r = reflect(-l, n);
	return (diffuseF * diffuseC * max(0, dot(n, l)) + specularF * specularC * pow(max(0, dot(r, v)), alpha)) * att; 
}

void main() {	
	//vec3 n = normalize(vert.normal_world);
	//vec3 v = normalize(camera_world - vert.position_world);
	
	vec3 diffuseColor = vec3(0.8,0.8,0.8);
	//diffuseColor *= normLifetime; 
	//texColor = n;
	//color = vec4(diffuseColor * materialCoefficients.x, 1); // ambient
	color = vec4(diffuseColor,normLifetimeFrag); 
	
	//color = vec4(materialCoefficients,1);
	//color = vec4(vert.normal_world, 1); 
	

	// add directional light contribution
	//color.rgb += phong(n, -dirL.direction, v, dirL.color * diffuseColor, materialCoefficients.y, dirL.color, materialCoefficients.z, specularAlpha, false, vec3(0));
			
	// add point light contribution
	//color.rgb += phong(n, pointL.position - vert.position_world, v, pointL.color * diffuseColor, materialCoefficients.y, pointL.color, materialCoefficients.z, specularAlpha, true, pointL.attenuation);
	
	part = vec4(1.0);
}
