#version 430 core
//*
//* Copyright 2018 Vienna University of Technology.
//* Institute of Computer Graphics and Algorithms.
//* This file is part of the ECG Lab Framework and must not be redistributed.
//*/

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;


//layout(location = 2) in vec2 uv;

out VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec2 uv;
} vert;

uniform mat4 modelMatrix[3001];
uniform float lifeTime[3001]; 
out float normLifetimeFrag; 

uniform mat4 ProjMatrix; 
uniform mat4 viewMatrix; 
//uniform mat3 normalMatrix;
//uniform mat4 viewProjMatrix;

void main() {
	mat4 _modelMatrix = modelMatrix[gl_InstanceID];
	normLifetimeFrag = lifeTime[gl_InstanceID]; 

	mat4 viewProjMatrix = ProjMatrix * viewMatrix; 
	//vert.normal_world = normalMatrix * normal;
	vert.normal_world = mat3(transpose(inverse(_modelMatrix))) * normal; 
	//vert.uv = uv;
	vec4 position_world_ = _modelMatrix * vec4(position, 1);
	vert.position_world = position_world_.xyz;
	gl_Position = viewProjMatrix * position_world_;
}
