#version 430 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

#define PI 3.1415926535897932384626433832795

uniform float time; 

out VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec2 uv;
} vert;

uniform mat4 modelMatrix;
uniform mat4 ProjMatrix; 
uniform mat4 viewMatrix; 

vec3 kugelcordinaten(vec3 pos) {
	vec3 result = vec3(0.0); 
	result.x = sqrt(pos.x * pos.x + pos.y * pos.y + pos.z * pos.z); // radius
	result.y = acos(pos.z / result.x); //anglev
	result.z = atan(pos.y, position.x); // angleh

	return result; 
}
vec3 cartesische(vec3 kugelCord) {
	vec3 result = vec3(0.0); 
	result.x = kugelCord.x * sin(kugelCord.y)  * cos(kugelCord.z); 
	result.y = kugelCord.x * sin(kugelCord.y) * sin(kugelCord.z); 
	result.z = kugelCord.x * cos(kugelCord.y); 

	return result; 
}

vec3 getNewPos(vec3 pos, float frequenzy, float height) {
	vec3 kugelCord = kugelcordinaten(pos); 
	float n = sin((pos.y + time)*frequenzy)*height; 
	vec3 newPos = position; 
	kugelCord.x = kugelCord.x + n;
	newPos = cartesische(kugelCord); 
	return kugelCord; 
}



void main() {
	mat4 viewProjMatrix = ProjMatrix * viewMatrix; 

	float frequenzy = 10.0; 
	float height = 0.2; 
	vec3 newPos = getNewPos(position, frequenzy, height); 
	newPos = cartesische(newPos); 
	vec3 kugelnormal = kugelcordinaten(normal); 
	float angleChange =  cos((position.y + time)*frequenzy)*height; 
	kugelnormal.y = kugelnormal.y + angleChange;

	vec3 cartNormal = cartesische(kugelnormal); 
	cartNormal = normalize(cartNormal); 

	vert.normal_world = mat3(transpose(inverse(modelMatrix))) * cartNormal; 
	vert.uv = uv;
	vec4 position_world_ = modelMatrix * vec4(newPos, 1);
	vert.position_world = position_world_.xyz;
	gl_Position = viewProjMatrix * position_world_;
}